/* Jacobians 6 */
#include "RoomHeating_OM_RH_model.h"
#include "RoomHeating_OM_RH_12jac.h"
#include "simulation/jacobian_util.h"
#include "util/omc_file.h"
int RoomHeating_OM_RH_functionJacH_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int RoomHeating_OM_RH_functionJacF_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int RoomHeating_OM_RH_functionJacD_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int RoomHeating_OM_RH_functionJacC_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int RoomHeating_OM_RH_functionJacB_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
/* constant equations */
/* dynamic equations */

/*
equation index: 43
type: SIMPLE_ASSIGN
room.Qout.$pDERA.dummyVarA = room.hAir * room.Awall * (room.RAT.SeedA - wall.Tisurf.SeedA)
*/
void RoomHeating_OM_RH_eqFunction_43(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 0;
  const int equationIndexes[2] = {1,43};
  jacobian->tmpVars[4] /* room.Qout.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = ((data->simulationInfo->realParameter[6] /* room.hAir PARAM */)) * (((data->simulationInfo->realParameter[0] /* room.Awall PARAM */)) * (jacobian->seedVars[0] /* room.RAT.SeedA SEED_VAR */ - jacobian->seedVars[2] /* wall.Tisurf.SeedA SEED_VAR */));
  TRACE_POP
}

/*
equation index: 44
type: SIMPLE_ASSIGN
$DER.room.energy.$pDERA.dummyVarA = room.eps * room.mdotat * (-room.cAir) * room.fs * room.RAT.SeedA
*/
void RoomHeating_OM_RH_eqFunction_44(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 1;
  const int equationIndexes[2] = {1,44};
  jacobian->resultVars[1] /* der(room.energy.$pDERA.dummyVarA) JACOBIAN_VAR */ = ((data->simulationInfo->realParameter[5] /* room.eps PARAM */)) * (((data->simulationInfo->realParameter[7] /* room.mdotat PARAM */)) * (((-(data->simulationInfo->realParameter[3] /* room.cAir PARAM */))) * (((data->localData[0]->realVars[16] /* room.fs variable */)) * (jacobian->seedVars[0] /* room.RAT.SeedA SEED_VAR */))));
  TRACE_POP
}

/*
equation index: 45
type: SIMPLE_ASSIGN
room.DT.$pDERA.dummyVarA = $DER.room.energy.$pDERA.dummyVarA - room.Qout.$pDERA.dummyVarA
*/
void RoomHeating_OM_RH_eqFunction_45(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 2;
  const int equationIndexes[2] = {1,45};
  jacobian->tmpVars[1] /* room.DT.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = jacobian->resultVars[1] /* der(room.energy.$pDERA.dummyVarA) JACOBIAN_VAR */ - jacobian->tmpVars[4] /* room.Qout.$pDERA.dummyVarA JACOBIAN_TMP_VAR */;
  TRACE_POP
}

/*
equation index: 46
type: SIMPLE_ASSIGN
$DER.room.RAT.$pDERA.dummyVarA = room.DT.$pDERA.dummyVarA * room.vAir * room.cAir * room.rohAir / (room.vAir * room.cAir * room.rohAir) ^ 2.0
*/
void RoomHeating_OM_RH_eqFunction_46(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 3;
  const int equationIndexes[2] = {1,46};
  modelica_real tmp0;
  tmp0 = ((data->simulationInfo->realParameter[10] /* room.vAir PARAM */)) * (((data->simulationInfo->realParameter[3] /* room.cAir PARAM */)) * ((data->simulationInfo->realParameter[9] /* room.rohAir PARAM */)));
  jacobian->resultVars[0] /* der(room.RAT.$pDERA.dummyVarA) JACOBIAN_VAR */ = (jacobian->tmpVars[1] /* room.DT.$pDERA.dummyVarA JACOBIAN_TMP_VAR */) * (((data->simulationInfo->realParameter[10] /* room.vAir PARAM */)) * (((data->simulationInfo->realParameter[3] /* room.cAir PARAM */)) * (DIVISION((data->simulationInfo->realParameter[9] /* room.rohAir PARAM */),(tmp0 * tmp0),"(room.vAir * room.cAir * room.rohAir) ^ 2.0"))));
  TRACE_POP
}

/*
equation index: 47
type: SIMPLE_ASSIGN
$DER.wall.Tosurf.$pDERA.dummyVarA = ((wall.Tisurf.SeedA - wall.Tosurf.SeedA) / wall.R - wall.ho * wall.aWall * wall.Tosurf.SeedA) / wall.C
*/
void RoomHeating_OM_RH_eqFunction_47(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 4;
  const int equationIndexes[2] = {1,47};
  jacobian->resultVars[3] /* der(wall.Tosurf.$pDERA.dummyVarA) JACOBIAN_VAR */ = DIVISION(DIVISION(jacobian->seedVars[2] /* wall.Tisurf.SeedA SEED_VAR */ - jacobian->seedVars[3] /* wall.Tosurf.SeedA SEED_VAR */,(data->localData[0]->realVars[22] /* wall.R variable */),"wall.R") - (((data->simulationInfo->realParameter[16] /* wall.ho PARAM */)) * (((data->simulationInfo->realParameter[13] /* wall.aWall PARAM */)) * (jacobian->seedVars[3] /* wall.Tosurf.SeedA SEED_VAR */))),(data->localData[0]->realVars[21] /* wall.C variable */),"wall.C");
  TRACE_POP
}

/*
equation index: 48
type: SIMPLE_ASSIGN
$DER.wall.Tisurf.$pDERA.dummyVarA = (wall.hi * wall.aWall * (room.RAT.SeedA - wall.Tisurf.SeedA) + (wall.Tosurf.SeedA - wall.Tisurf.SeedA) / wall.R) / wall.C
*/
void RoomHeating_OM_RH_eqFunction_48(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 5;
  const int equationIndexes[2] = {1,48};
  jacobian->resultVars[2] /* der(wall.Tisurf.$pDERA.dummyVarA) JACOBIAN_VAR */ = DIVISION(((data->simulationInfo->realParameter[15] /* wall.hi PARAM */)) * (((data->simulationInfo->realParameter[13] /* wall.aWall PARAM */)) * (jacobian->seedVars[0] /* room.RAT.SeedA SEED_VAR */ - jacobian->seedVars[2] /* wall.Tisurf.SeedA SEED_VAR */)) + DIVISION(jacobian->seedVars[3] /* wall.Tosurf.SeedA SEED_VAR */ - jacobian->seedVars[2] /* wall.Tisurf.SeedA SEED_VAR */,(data->localData[0]->realVars[22] /* wall.R variable */),"wall.R"),(data->localData[0]->realVars[21] /* wall.C variable */),"wall.C");
  TRACE_POP
}

OMC_DISABLE_OPT
int RoomHeating_OM_RH_functionJacA_constantEqns(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH

  int index = RoomHeating_OM_RH_INDEX_JAC_A;
  
  TRACE_POP
  return 0;
}

int RoomHeating_OM_RH_functionJacA_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH

  int index = RoomHeating_OM_RH_INDEX_JAC_A;
  RoomHeating_OM_RH_eqFunction_43(data, threadData, jacobian, parentJacobian);
  RoomHeating_OM_RH_eqFunction_44(data, threadData, jacobian, parentJacobian);
  RoomHeating_OM_RH_eqFunction_45(data, threadData, jacobian, parentJacobian);
  RoomHeating_OM_RH_eqFunction_46(data, threadData, jacobian, parentJacobian);
  RoomHeating_OM_RH_eqFunction_47(data, threadData, jacobian, parentJacobian);
  RoomHeating_OM_RH_eqFunction_48(data, threadData, jacobian, parentJacobian);
  TRACE_POP
  return 0;
}

int RoomHeating_OM_RH_initialAnalyticJacobianH(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int RoomHeating_OM_RH_initialAnalyticJacobianF(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int RoomHeating_OM_RH_initialAnalyticJacobianD(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int RoomHeating_OM_RH_initialAnalyticJacobianC(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int RoomHeating_OM_RH_initialAnalyticJacobianB(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
OMC_DISABLE_OPT
int RoomHeating_OM_RH_initialAnalyticJacobianA(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  size_t count;

  FILE* pFile = openSparsePatternFile(data, threadData, "RoomHeating_OM_RH_JacA.bin");
  
  initAnalyticJacobian(jacobian, 4, 4, 14, NULL, jacobian->sparsePattern);
  jacobian->sparsePattern = allocSparsePattern(4, 8, 3);
  jacobian->availability = JACOBIAN_AVAILABLE;
  
  /* read lead index of compressed sparse column */
  count = omc_fread(jacobian->sparsePattern->leadindex, sizeof(unsigned int), 4+1, pFile, FALSE);
  if (count != 4+1) {
    throwStreamPrint(threadData, "Error while reading lead index list of sparsity pattern. Expected %d, got %zu", 4+1, count);
  }
  
  /* read sparse index */
  count = omc_fread(jacobian->sparsePattern->index, sizeof(unsigned int), 8, pFile, FALSE);
  if (count != 8) {
    throwStreamPrint(threadData, "Error while reading row index list of sparsity pattern. Expected %d, got %zu", 4+1, count);
  }
  
  /* write color array */
  /* color 1 with 1 columns */
  readSparsePatternColor(threadData, pFile, jacobian->sparsePattern->colorCols, 1, 1);
  /* color 2 with 1 columns */
  readSparsePatternColor(threadData, pFile, jacobian->sparsePattern->colorCols, 2, 1);
  /* color 3 with 2 columns */
  readSparsePatternColor(threadData, pFile, jacobian->sparsePattern->colorCols, 3, 2);
  
  omc_fclose(pFile);
  
  TRACE_POP
  return 0;
}



